from enum import Enum


class TokenDefinition(Enum):
    """ Keywords """
    # define keywords
    Library = r'lib'
    Class = r'class'
    Function = r'func'
    Variable = r'var'
    Use = r'use'
    From = r'from'
    As = r'as'

    # builtin functions
    Output = r'output'
    Input = r'input'
    Length = r'length'
    Range = r'range'
    Round = r'round'
    Exit = r'exit'

    # normal keywords
    If = r'if'
    ElseIf = r'elseif'
    Else = r'else'
    Continue = r'continue'
    Return = r'return'

    # loops
    While = r'while'
    For = r'for'
    In = r'in'

    # access
    Public = r'public'
    This = r'this'

    """ Chars """
    # format
    LeftBrace = r'\{'
    RightBrace = r'\}'
    LeftParenthesis = r'\('
    RightParenthesis = r'\)'
    LeftBracket = r'\['
    RightBracket = r'\]'
    Semicolon = r'\;'
    Colon = r'\:'
    Comma = r'\,'
    Point = r'\.'
    # expr
    Plus = r'\+'
    Minus = r'\-'
    Asterisk = r'\*'
    Slash = r'\/'
    Equal = r'\='
    Caret = r'\^'

    """ Values """
    ValueString = r'\".*?\"'
    ValueNumber = r'\d+'

    # bool
    BoolTrue = r'true'
    BoolFalse = r'false'

    """ Datatypes """
    Empty = r'empty'
    Number = r'Number'
    String = r'string'
    Bool = r'bool'
    List = r'list'
    Dict = r'dict'
    Void = r'void'

    """ other """
    Name = r'[a-zA-Z_][a-zA-Z0-9_]*'
